#include<bits/stdc++.h>

using namespace std;
const long long maxN=1e5+3;
vector<vector<long long>> v(maxN);
long long dp[maxN];

long long brdeca(int vr) {
	if(dp[vr]!=0) return dp[vr];
	int br=0;
	for(auto t: v[vr]){
		br+=brdeca(t)+1;
	}
	return (dp[vr]=br);
}
int main() {
ios_base::sync_with_stdio(0);
cin.tie(NULL);
cout.tie(NULL);
long long n; cin>>n;
for(long long i=0;i<n-1;i++){
	long long u,v1; cin>>u>>v1;
	u--,v1--;
	v[u].push_back(v1);
	///cout<<u<<' '<<v1<<endl;
}
long long q; cin>>q;
while(q-->0){
	long long m; cin>>m;
	cout<<brdeca(m-1)<<'\n';
}


return 0;
}